-----------------------------------------------------------------------------------------------------
-- Inicio Script 26 Mayo 2015 Oscar Garcia 	                                                   --
-- Ajuste para el menu de Parametrizacion                                                          --
-----------------------------------------------------------------------------------------------------

PRINT 'Creando objetos RecursosExternos...'
IF EXISTS (select 1 from sys.tables where name = 'RecursosExternos')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[RecursosExternos](
			[idRecurso] [int] IDENTITY(1,1) NOT NULL,
			[idEmpresa] [int] NOT NULL,
			[Descripcion] [varchar](250) NOT NULL,
			[Url] [varchar](500) NULL,
			[Habilitado] [int] NULL,
		 CONSTRAINT [PK_RecursosExternos] PRIMARY KEY CLUSTERED 
		(
			[idRecurso] ASC
		)) ON [PRIMARY];

		DECLARE @idEmpresa INT
		select @idEmpresa = idEmpresa from Empresa where idEmpresa != 1;
		insert into RecursosExternos values (@idEmpresa, 'URL que redirige hacia aplicacin externa de directorio activo para recordar contrasea', 'http://srvoim:7777/customOimWar/resetPass.xhtml', '0');
		insert into RecursosExternos values (@idEmpresa, 'URL que redirige hacia aplicacin externa de la empresa y que muestra informacin til', 'http://business.policia.gov.co:9704/analytics/saw.dll?Dashboard&NQUser=consulta_arcoi', '0');
		insert into RecursosExternos values (@idEmpresa, 'Ruta alterna en la que se van a guardar las Referencias a Papeles de Trabajo', '\\Srvpncfiles\AUDIRISK\inetpub\wwwroot\AudiRisk\RefPapeles\', '0');
		PRINT 'Se han creado con exito objetos RecursosExternos.'
	END

PRINT 'Creando Menu RecursosExternos...'
IF EXISTS (SELECT 1 FROM Menu WHERE idMenu = '0403020109')
	BEGIN
		PRINT 'El Menu ya existe.'
	END
ELSE
	BEGIN
		insert into Menu values ('0403020109', 'Recursos Externos', '~/Configuracion/ListarRecursosExternos.aspx', '0')
		insert into MenuPerfil values ('0403020109', '14')
		insert into MenuPerfil values ('0403020109', '16')
		insert into MenuPerfil values ('0403020109', '18')
		insert into MenuPerfil values ('0403020109', '19')
		PRINT 'El Menu se cre con xito.'
	END

PRINT 'Actualizando Menu Base de Conocimiento Empresa...'
update Menu set descripcion = 'Configuracin de Moneda',  enlace = '~/Configuracion/ListarMonedas.aspx' where idMenu = '0403020206'
update Menu set descripcion = 'Activos Impactados',  enlace = '~/Configuracion/ListarActivosImpactados.aspx' where idMenu = '0403020207'
update Menu set descripcion = 'Agentes Generadores',  enlace = '~/Configuracion/ListarAgenteGenerador.aspx' where idMenu = '0403020208'
update Menu set descripcion = 'Vulnerabilidades',  enlace = '~/Configuracion/ListarVulnerabilidades.aspx' where idMenu = '0403020209'
update Menu set descripcion = 'Frecuencias de Ejecucin de Controles',  enlace = '~/Configuracion/ListarFrecuenciaEjecucionControl.aspx' where idMenu = '0403020210'
update Menu set descripcion = 'Frecuencias de ocurrencia de la amenaza',  enlace = '~/Configuracion/ListarFrecuenciaAmenaza.aspx' where idMenu = '0403020211'
update Menu set descripcion = 'Tipos de Impacto',  enlace = '~/Configuracion/SeleccionarTipoImpacto.aspx' where idMenu = '0403020212'
update Menu set descripcion = 'Caractersticas de la Informacin de Negocios',  enlace = '~/audConfiguracion/ListarCriterioCobit.aspx' where idMenu = '0403020213'
PRINT 'Fin actualizacion Menu Base de Conocimiento Empresa'


PRINT 'Creando Menu Tecnicas de Auditoria...'
IF EXISTS (SELECT 1 FROM Menu WHERE idMenu = '0403020214')
	BEGIN
		PRINT 'El Menu ya existe.'
		IF NOT EXISTS (SELECT 1 FROM MenuPerfil WHERE idMenu = '0403020214')
			BEGIN
				INSERT INTO MenuPerfil VALUES ('0403020214', '14')
				INSERT INTO MenuPerfil VALUES ('0403020214', '16')
				INSERT INTO MenuPerfil VALUES ('0403020214', '18')
				INSERT INTO MenuPerfil VALUES ('0403020214', '19')
			END
	END
ELSE
	BEGIN
		INSERT INTO Menu VALUES ('0403020214', 'Tecnicas de Auditoria', '~/audConfiguracion/TecnicaAuditoria.aspx', '0')
		INSERT INTO MenuPerfil VALUES ('0403020214', '14')
		INSERT INTO MenuPerfil VALUES ('0403020214', '16')
		INSERT INTO MenuPerfil VALUES ('0403020214', '18')
		INSERT INTO MenuPerfil VALUES ('0403020214', '19')
		PRINT 'El Menu se cre con xito.'
	END
	
PRINT 'Creando Menu Auditorias a Realizar...'
IF EXISTS (SELECT 1 FROM Menu WHERE idMenu = '0403020215')
	BEGIN
		PRINT 'El Menu ya existe.'
		IF NOT EXISTS (SELECT 1 FROM MenuPerfil WHERE idMenu = '0403020215')
			BEGIN
				INSERT INTO MenuPerfil VALUES ('0403020215', '14')
				INSERT INTO MenuPerfil VALUES ('0403020215', '16')
				INSERT INTO MenuPerfil VALUES ('0403020215', '18')
				INSERT INTO MenuPerfil VALUES ('0403020215', '19')
			END
	END
ELSE
	BEGIN
		INSERT INTO Menu VALUES ('0403020215', 'Auditorias a Realizar', '~/Configuracion/ListarAuditoriasRealizar.aspx', '0')
		INSERT INTO MenuPerfil VALUES ('0403020215', '14')
		INSERT INTO MenuPerfil VALUES ('0403020215', '16')
		INSERT INTO MenuPerfil VALUES ('0403020215', '18')
		INSERT INTO MenuPerfil VALUES ('0403020215', '19')
		PRINT 'El Menu se cre con xito.'
	END


PRINT 'Insertando ProbabilidadEmpresa y FrecuenciaOcurrenciaEmpresa para MORRAOS...'
IF EXISTS 
		(SELECT 1 
			FROM ProbabilidadEmpresa
			WHERE idEmpresa = 1 
			AND idProbabilidad = 8
			AND idDescripcion = 156)
		
	BEGIN
		PRINT 'ProbabilidadEmpresa para MORRAOS ya existe.'
	END
ELSE
	BEGIN
		INSERT INTO ProbabilidadEmpresa VALUES ('1', '8', '156')
		PRINT 'ProbabilidadEmpresa para MORRAOS se insert con xito.'
	END
IF EXISTS 
		(SELECT 1 
			FROM FrecuenciaOcurrenciaEmpresa
			WHERE idEmpresa = 1 
			AND idDescripcion = 193
			AND idProbabilidad = 8)		
	BEGIN
		PRINT 'FrecuenciaOcurrenciaEmpresa para MORRAOS ya existe.'
	END
ELSE
	BEGIN
		INSERT INTO FrecuenciaOcurrenciaEmpresa VALUES ('1', '193', '30.000000', '8')		
		PRINT 'FrecuenciaOcurrenciaEmpresa para MORRAOS se insert con xito.'
	END


PRINT 'Creando objetos ClaseAuditoria...'
IF EXISTS (select 1 from sys.tables where name = 'ClaseAuditoria')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[ClaseAuditoria](
			[idClaseAuditoria] [int] IDENTITY(1,1) NOT NULL,
			[nombreClase] [varchar](250) NOT NULL,
			[Descripcion] [varchar](3000) NOT NULL,
		CONSTRAINT [PK_idClaseAuditoria] PRIMARY KEY CLUSTERED 
		(
			[idClaseAuditoria] ASC
		)) ON [PRIMARY];
		insert into ClaseAuditoria Values ('Integral', 'La auditora integral consiste en la verificacin realizada a la empresa en todos los procesos y procedimientos que en esta se realizan');
		insert into ClaseAuditoria Values ('Especifica', 'La auditora especfica consiste en la verificacin realizada en uno o varios escenarios de un proceso, procedimiento y/o actividad determinada, la cual solo podr ser ordenada por el Gerente o Subgerente de la empresa');
		insert into ClaseAuditoria Values ('Calidad', 'La auditora de calidad, se define como un Proceso sistemtico, independiente y documentado  para obtener evidencias de la auditora (registros, declaraciones de hechos o cualquier  otra informacin) y evaluarlas de manera objetiva, esta permite determinar la conformidad del Sistema de Gestin de la Calidad con los requisitos establecidos en la norma de calidad y as mismo verificar la implementacin y mantenimiento del Sistema de Gestin Integral');
		insert into ClaseAuditoria Values ('Combinada', 'La auditora combinada consiste en auditar los Sistemas de Gestin de Calidad y el Medioambiente');
		insert into ClaseAuditoria Values ('Seguimiento', 'La auditora de seguimiento consiste en la verificacin realizada al proceso y/o actividades de un proceso respecto de los planes de mejoramiento');
		ALTER TABLE [Estudio] ADD [idClaseAuditoria] [int] NULL;
		PRINT 'Se han creado con exito objetos ClaseAuditoria.';
	END

PRINT 'Creando objetos ClaseHallazgo...'
IF EXISTS (select 1 from sys.tables where name = 'ClaseHallazgo')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[ClaseHallazgo](
			[idClaseHallazgo] [int] IDENTITY(1,1) NOT NULL,
			[Descripcion] [varchar](250) NOT NULL,
			[Detalle] [varchar](3000) NULL,
		CONSTRAINT [PK_ClaseHallazgo] PRIMARY KEY CLUSTERED 
		(
			[idClaseHallazgo] ASC
		)) ON [PRIMARY];
		insert into ClaseHallazgo values ('Administrativo', 'Por definicin un hallazgo administrativo es un hecho que demuestra que la gestin fiscal de un sujeto de control no se est desarrollando de acuerdo a los principios generales establecidos');
		insert into ClaseHallazgo values ('Disciplinario', 'Hallazgo administrativo donde se configura que los servidores pblicos o los particulares que transitoriamente ejerzan funciones pblicas, han incurrido en alguna violacin a las normas disciplinarias');
		insert into ClaseHallazgo values ('Fiscal', 'Son situaciones donde se observa un mal uso de los recursos asignados para el cumplimiento de la funcin administrativa y conlleva a un detrimento del patrimonio pblico');
		insert into ClaseHallazgo values ('Penal', 'Son situaciones donde se evidencia que en el ejercicio de sus funciones administrativas, se est cometiendo una accin tipificada como delito en el cdigo penal');
		insert into ClaseHallazgo values ('Otro', 'Otro');
		PRINT 'Se han creado con exito objetos ClaseHallazgo.';
	END


PRINT 'Creando objetos NivelHallazgo...'
IF EXISTS (select 1 from sys.tables where name = 'NivelHallazgo')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[NivelHallazgo](
			[idNivelHallazgo] [int] IDENTITY(1,1) NOT NULL,
			[Descripcion] [varchar](250) NOT NULL,
			[Detalle] [varchar](3000) NULL,
		CONSTRAINT [PK_NivelHallazgo] PRIMARY KEY CLUSTERED 
		(
			[idNivelHallazgo] ASC
		)) ON [PRIMARY];
		insert into NivelHallazgo values ('Estrategico', 'Son aquellos hallazgos evidenciados en un proceso, como resultado de una auditora, cuya responsabilidad y competencia para subsanarlos, recae en los dueos de procesos');
		insert into NivelHallazgo values ('Tactico', 'Son aquellos hallazgos cuya responsabilidad y competencia para subsanarlos recae en los dueos de procesos');
		insert into NivelHallazgo values ('Operacional', 'Son aquellos hallazgos evidenciados en la auditora, relacionados directamente con la ejecucin de cualquier proceso o actividad, comprendida dentro del Sistema de Gestin Integral de la empresa');
		PRINT 'Se han creado con exito objetos NivelHallazgo.';
	END

------------------------------------------------------------------------------------------
-- Fin Script 26 Mayo 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------
-- Inicio Script 26 Mayo 2015 Oscar Garcia 	                                                   --
-- Ajuste para ingresar nuevos campos en Hallazgos de Auditorias                                   --
-----------------------------------------------------------------------------------------------------

PRINT 'Modificando tabla HallazgosAuditoria...'
ALTER TABLE HallazgosAuditoria
	ADD [idNivelHallazgo] [int] NULL,
		[CodigoInterno] [varchar](300) NULL,
		[idClaseHallazgo] [int] NULL
GO
PRINT 'Fin tabla HallazgosAuditoria...'

PRINT 'Modificando tabla ReferenciasHallazgosAuditoria...'
ALTER TABLE ReferenciasHallazgosAuditoria
	ADD ruta varchar(500) NULL
GO
PRINT 'Fin tabla ReferenciasHallazgosAuditoria...'


PRINT 'Creando Menu Clases de Auditoria...'
IF EXISTS (SELECT 1 FROM Menu WHERE idMenu = '0403020110')
	BEGIN
		PRINT 'El Menu ya existe.'
		IF NOT EXISTS (SELECT 1 FROM MenuPerfil WHERE idMenu = '0403020110')
			BEGIN
				insert into MenuPerfil values ('0403020110', '14')
				insert into MenuPerfil values ('0403020110', '16')
				insert into MenuPerfil values ('0403020110', '18')
				insert into MenuPerfil values ('0403020110', '19')
			END
	END
ELSE
	BEGIN
		insert into Menu values ('0403020110', 'Clases de Auditoria', '~/Configuracion/ListarClasesAuditoria.aspx', '0')
		insert into MenuPerfil values ('0403020110', '14')
		insert into MenuPerfil values ('0403020110', '16')
		insert into MenuPerfil values ('0403020110', '18')
		insert into MenuPerfil values ('0403020110', '19')		
		PRINT 'El Menu se cre con xito.'
	END
	

PRINT 'Creando Menu Clases de Hallazgo...'
IF EXISTS (SELECT 1 FROM Menu WHERE idMenu = '0403020111')
	BEGIN
		PRINT 'El Menu ya existe.'
		IF NOT EXISTS (SELECT 1 FROM MenuPerfil WHERE idMenu = '0403020111')
			BEGIN
				insert into MenuPerfil values ('0403020111', '14')
				insert into MenuPerfil values ('0403020111', '16')
				insert into MenuPerfil values ('0403020111', '18')
				insert into MenuPerfil values ('0403020111', '19')
			END
	END
ELSE
	BEGIN
		insert into Menu values ('0403020111', 'Clases de Hallazgo', '~/Configuracion/ListarClasesHallazgo.aspx', '0')
		insert into MenuPerfil values ('0403020111', '14')
		insert into MenuPerfil values ('0403020111', '16')
		insert into MenuPerfil values ('0403020111', '18')
		insert into MenuPerfil values ('0403020111', '19')		
		PRINT 'El Menu se cre con xito.'
	END
	
PRINT 'Creando Menu Niveles de Hallazgo...'
IF EXISTS (SELECT 1 FROM Menu WHERE idMenu = '0403020112')
	BEGIN
		PRINT 'El Menu ya existe.'
		IF NOT EXISTS (SELECT 1 FROM MenuPerfil WHERE idMenu = '0403020112')
			BEGIN
				insert into MenuPerfil values ('0403020112', '14')
				insert into MenuPerfil values ('0403020112', '16')
				insert into MenuPerfil values ('0403020112', '18')
				insert into MenuPerfil values ('0403020112', '19')
			END
	END
ELSE
	BEGIN
		insert into Menu values ('0403020112', 'Niveles de Hallazgo', '~/Configuracion/ListarNivelesHallazgo.aspx', '0')
		insert into MenuPerfil values ('0403020112', '14')
		insert into MenuPerfil values ('0403020112', '16')
		insert into MenuPerfil values ('0403020112', '18')
		insert into MenuPerfil values ('0403020112', '19')		
		PRINT 'El Menu se cre con xito.'
	END

------------------------------------------------------------------------------------------
-- Fin Script 26 Mayo 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------
-- Inicio Script 26 Mayo 2015 Oscar Garcia 	                                                   --
-- Ajuste para Documentacion de Amenazas                                                           --
-----------------------------------------------------------------------------------------------------

PRINT 'Modificando tabla EstudioAmenaza...'
ALTER TABLE EstudioAmenaza
	ADD [idArea] [int] NULL,
		[idCargo] [int] NULL
GO
PRINT 'Fin tabla EstudioAmenaza...'

PRINT 'Modificando tabla ReferenciaPapelTrabajo...'
ALTER TABLE ReferenciaPapelTrabajo
	ADD ruta varchar(500) NULL
GO
PRINT 'Fin tabla ReferenciaPapelTrabajo...'

------------------------------------------------------------------------------------------
-- Fin Script 26 Mayo 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------
-- Inicio Script 26 Mayo 2015 Oscar Garcia 	                                                   --
-- Ajuste para Implementacin de nuevo menu en Planeacion de Auditoria                             --
-----------------------------------------------------------------------------------------------------

PRINT 'Actualizando Menu Planeacion Anual de la Auditoria...'
UPDATE Menu
	SET descripcion = 'Seleccionar Procesos Trabajos para el Plan Anual - Tipo Auditoria'
	WHERE idMenu = '0402020301'

UPDATE Menu
	SET descripcion = 'Definir Auditorias por Proceso o Sistema', enlace = '~/audPlaneacionAuditoria/DefinirAuditoriasProceso.aspx'
	WHERE idMenu = '0402020302'

UPDATE Menu
	SET descripcion = 'Programar Auditorias a Realizar - Proceso', enlace = '~/audPlaneacionAuditoria/ListarTrabajosCronogramaNuevo.aspx'
	WHERE idMenu = '0402020303'
PRINT 'Fin actualizacion Menu Planeacion Anual de la Auditoria'

PRINT 'Creando Menu Generar Plan Anual Auditorias a Realizar - Proceso...'
IF EXISTS (SELECT 1 FROM Menu WHERE idMenu = '0402020304')
	BEGIN
		PRINT 'El Menu ya existe.'		
	END
ELSE
	BEGIN
		INSERT INTO Menu values ('0402020304', 'Generar Plan Anual Auditorias a Realizar - Proceso', '~/audPlaneacionAuditoria/GenerarPlan.aspx', '1')
		INSERT INTO MenuEstadosPlaneacionAnualInternas VALUES ('0402020304', '1', '2011', 'P')
		INSERT INTO Pagina VALUES ('Generar Plan Anual Auditorias a Realizar - Proceso', 'audPlaneacionAuditoria/GenerarPlan.aspx', '0', 'audPlaneacionAuditoria', '0402020304', NULL)

		DECLARE @idPagina INT
		SELECT @idPagina = idPagina FROM Pagina where nombre = 'Generar Plan Anual Auditorias a Realizar - Proceso'
		INSERT INTO PaginaPerfil VALUES (@idPagina, '14')
		INSERT INTO PaginaPerfil VALUES (@idPagina, '16')
		INSERT INTO PaginaPerfil VALUES (@idPagina, '18')
		INSERT INTO PaginaPerfil VALUES (@idPagina, '19')		
		PRINT 'El Menu se cre con xito.'
	END

PRINT 'Creando objetos AuditoriasPorProceso...'
IF EXISTS (select 1 from sys.tables where name = 'AuditoriasPorProceso')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[AuditoriasPorProceso](
			[idProcesoAuditoria] [int] IDENTITY(1,1) NOT NULL,
			[idTrabajoAuditoria] [int] NOT NULL,
			[idAuditoriaRealizar] [int] NOT NULL,
			[fechaInicio] [datetime] NULL,
			[fechaFin] [datetime] NULL,
			[duracionEstimada] [numeric](10, 2) NULL,
			[alcance] [varchar](700) NULL,
			[cantidadAuditores] [int] NULL,
			[horasDiariasLab] [numeric](10, 2) NULL,
			[diasFeriados] [int] NULL,
			[duracionDias] [int] NULL,
			[duracionSemana] [numeric](5, 2) NULL,
			[otrosGastos] [numeric](18, 2) NULL,
			[horasSupervisor] [numeric](5, 2) NULL,
			[horasAuditor] [numeric](5, 2) NULL,
			[diasCalendario] [int] NULL,
			[fechaFinConFeriados] [datetime] NULL,
			[annoFiscal] [int] NULL,
			[idEmpresaAuditora] [int] NULL,
			[terminado] [int] NULL,
		 CONSTRAINT [PK_AuditoriasPorProceso] PRIMARY KEY CLUSTERED 
		(
			[idProcesoAuditoria] ASC
		)) ON [PRIMARY]
		PRINT 'Se han creado con exito objetos AuditoriasPorProceso.'
	END

PRINT 'Creando objetos NombresAuditoriaRealizar...'
IF EXISTS (select 1 from sys.tables where name = 'NombresAuditoriaRealizar')
	BEGIN
		PRINT 'Ya existen los objetos.'
		DECLARE @idEmpresa1 INT
		select @idEmpresa1 = idEmpresa from Empresa where idEmpresa != 1;
		IF NOT EXISTS (select * from NombresAuditoriaRealizar 
				where nombreAuditoriaRealizar = 'Auditoria Completa (Evaluar CI + PC + PS)'
				AND idEmpresa = @idEmpresa1)
			BEGIN
				INSERT INTO NombresAuditoriaRealizar VALUES ('Auditoria Completa (Evaluar CI + PC + PS)', 'Auditoria Completa (Evaluar CI + PC + PS)', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Auditoria de Control Interno', 'Auditoria de Control Interno', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Pruebas de Cumplimiento', 'Pruebas de Cumplimiento', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Pruebas Sustantivas', 'Pruebas Sustantivas', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Prueba de Auditoria (Pruebas de Cumplimiento y Pruebas Sustantivas)', 'Prueba de Auditoria (Pruebas de Cumplimiento y Pruebas Sustantivas)', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Control Interno', 'Seguimiento a Hallazgos de Control Interno', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Pruebas de Cumplimiento', 'Seguimiento a Hallazgos de Pruebas de Cumplimiento', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Pruebas Sustantivas', 'Seguimiento a Hallazgos de Pruebas Sustantivas', @idEmpresa1)
				INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento Completo (Hallazgos CI + PC + PS)', 'Seguimiento Completo (Hallazgos CI + PC + PS)', @idEmpresa1)
			END				
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[NombresAuditoriaRealizar](
			[idAuditoriaRealizar] [int] IDENTITY(1,1) NOT NULL,
			[nombreAuditoriaRealizar] [varchar](255) NOT NULL,
			[descripcionAuditoria] [varchar](200) NULL,
			[idEmpresa] [int] NULL
		 CONSTRAINT [PK_NombresAuditoriaRealizar] PRIMARY KEY CLUSTERED 
		(
			[idAuditoriaRealizar] ASC
		)) ON [PRIMARY];
		
		DECLARE @idEmpresa2 INT
		select @idEmpresa2 = idEmpresa from Empresa where idEmpresa != 1;
		INSERT INTO NombresAuditoriaRealizar VALUES ('Auditoria Completa (Evaluar CI + PC + PS)', 'Auditoria Completa (Evaluar CI + PC + PS)', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Auditoria de Control Interno', 'Auditoria de Control Interno', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Pruebas de Cumplimiento', 'Pruebas de Cumplimiento', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Pruebas Sustantivas', 'Pruebas Sustantivas', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Prueba de Auditoria (Pruebas de Cumplimiento y Pruebas Sustantivas)', 'Prueba de Auditoria (Pruebas de Cumplimiento y Pruebas Sustantivas)', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Control Interno', 'Seguimiento a Hallazgos de Control Interno', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Pruebas de Cumplimiento', 'Seguimiento a Hallazgos de Pruebas de Cumplimiento', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Pruebas Sustantivas', 'Seguimiento a Hallazgos de Pruebas Sustantivas', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento Completo (Hallazgos CI + PC + PS)', 'Seguimiento Completo (Hallazgos CI + PC + PS)', '1')
		INSERT INTO NombresAuditoriaRealizar VALUES ('Auditoria Completa (Evaluar CI + PC + PS)', 'Auditoria Completa (Evaluar CI + PC + PS)', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Auditoria de Control Interno', 'Auditoria de Control Interno', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Pruebas de Cumplimiento', 'Pruebas de Cumplimiento', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Pruebas Sustantivas', 'Pruebas Sustantivas', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Prueba de Auditoria (Pruebas de Cumplimiento y Pruebas Sustantivas)', 'Prueba de Auditoria (Pruebas de Cumplimiento y Pruebas Sustantivas)', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Control Interno', 'Seguimiento a Hallazgos de Control Interno', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Pruebas de Cumplimiento', 'Seguimiento a Hallazgos de Pruebas de Cumplimiento', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento a Hallazgos de Pruebas Sustantivas', 'Seguimiento a Hallazgos de Pruebas Sustantivas', @idEmpresa2)
		INSERT INTO NombresAuditoriaRealizar VALUES ('Seguimiento Completo (Hallazgos CI + PC + PS)', 'Seguimiento Completo (Hallazgos CI + PC + PS)', @idEmpresa2)
		PRINT 'Se han creado con exito objetos NombresAuditoriaRealizar.'
	END

PRINT 'Creando objetos ResponsableAuditoriaPorProceso...'
IF EXISTS (select 1 from sys.tables where name = 'ResponsableAuditoriaPorProceso')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[ResponsableAuditoriaPorProceso](
			[idProcesoAuditoria] [int] NOT NULL,
			[idResponsableAuditoriaPorProceso] [int] IDENTITY(1,1) NOT NULL,
			[nombreResponsable] [varchar](200) NOT NULL,
			[idCargo] [int] NULL,
			[idResponsabilidad] [int] NULL,
			[vlHora] [numeric](18, 0) NULL,
			[NoHoras] [int] NULL,
			[annoFiscal] [int] NOT NULL,
			[idEmpresa] [int] NOT NULL,
		 CONSTRAINT [PK_ResponsableAuditoriaPorProceso] PRIMARY KEY CLUSTERED 
		(
			[idResponsableAuditoriaPorProceso] ASC
		)) ON [PRIMARY];
		ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_ResponsableAuditoriaPorProceso_AuditoriasPorProceso] FOREIGN KEY([idProcesoAuditoria])
		REFERENCES [dbo].[AuditoriasPorProceso] ([idProcesoAuditoria]);
		ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso] CHECK CONSTRAINT [FK_ResponsableAuditoriaPorProceso_AuditoriasPorProceso];
		ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_ResponsableAuditoriaPorProceso_CargosNivelesAuditorPlaneacion] FOREIGN KEY([idCargo])
		REFERENCES [dbo].[CargosNivelesAuditorPlaneacion] ([idCargoNivel]);
		ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso] CHECK CONSTRAINT [FK_ResponsableAuditoriaPorProceso_CargosNivelesAuditorPlaneacion];
		ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_ResponsableAuditoriaPorProceso_NivelesAuditorPlaneacion] FOREIGN KEY([idResponsabilidad]) REFERENCES [dbo].[NivelesAuditorPlaneacion] ([idNivel]);
		ALTER TABLE [dbo].[ResponsableAuditoriaPorProceso] CHECK CONSTRAINT [FK_ResponsableAuditoriaPorProceso_NivelesAuditorPlaneacion];
		PRINT 'Se han creado con exito objetos ResponsableAuditoriaPorProceso.'
	END

PRINT 'Creando objetos OtrosGastosAuditoriasPorProceso...'
IF EXISTS (select 1 from sys.tables where name = 'OtrosGastosAuditoriasPorProceso')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[OtrosGastosAuditoriasPorProceso](
			[idConcepto] [int] IDENTITY(1,1) NOT NULL,
			[NombreConcepto] [varchar](150) NOT NULL,
			[DescripcionConcepto] [varchar](150) NOT NULL,
			[costoUnitario] [numeric](18, 2) NOT NULL,
			[costoTotal] [numeric](18, 2) NOT NULL,
			[Cantidad] [int] NOT NULL,
			[idEmpresa] [int] NOT NULL,
			[annoFiscal] [int] NOT NULL,
			[idProcesoAuditoria] [int] NULL,
		 CONSTRAINT [PK_OtrosGastosAuditoriasPorProceso] PRIMARY KEY CLUSTERED 
		(
			[idConcepto] ASC
		)) ON [PRIMARY];
		ALTER TABLE [dbo].[OtrosGastosAuditoriasPorProceso]  WITH CHECK ADD  CONSTRAINT [FK_OtrosGastosAuditoriasPorProceso_AuditoriasPorProceso] FOREIGN KEY([idProcesoAuditoria])
		REFERENCES [dbo].[AuditoriasPorProceso] ([idProcesoAuditoria]);
		ALTER TABLE [dbo].[OtrosGastosAuditoriasPorProceso] CHECK CONSTRAINT [FK_OtrosGastosAuditoriasPorProceso_AuditoriasPorProceso];
		PRINT 'Se han creado con exito objetos OtrosGastosAuditoriasPorProceso.'
	END


PRINT 'Creando objetos SeguimientoAuditoriasPorProceso...'
IF EXISTS (select 1 from sys.tables where name = 'SeguimientoAuditoriasPorProceso')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[SeguimientoAuditoriasPorProceso](
			[idSeguimiento] [int] IDENTITY(1,1) NOT NULL,
			[idProcesoAuditoria] [int] NOT NULL,
			[fechaseguimiento] [datetime] NOT NULL,
			[porcentajeAvance] [int] NOT NULL,
			[descripcionAvance] [varchar](3000) NOT NULL,
			[comentarios] [varchar](3000) NOT NULL,
			[idSupervisor] [int] NOT NULL,
			[Estado] [char](1) NOT NULL,
			[idEmpresa] [int] NULL,
			[annoFiscal] [int] NULL,
		 CONSTRAINT [PK_seguimientoAuditoriasPorProceso] PRIMARY KEY CLUSTERED 
		(
			[idSeguimiento] ASC
		)) ON [PRIMARY];
		ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] WITH CHECK ADD  CONSTRAINT [FK_seguimientoAuditoriasPorProceso_AuditoriasPorProceso] FOREIGN KEY([idProcesoAuditoria])
		REFERENCES [dbo].[AuditoriasPorProceso] ([idProcesoAuditoria]);
		ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] CHECK CONSTRAINT [FK_seguimientoAuditoriasPorProceso_AuditoriasPorProceso];
		ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] WITH CHECK ADD CONSTRAINT [FK_seguimientoAuditoriasPorProceso_usuario] FOREIGN KEY([idSupervisor])
		REFERENCES [dbo].[Usuario] ([idUsuario]);
		ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] CHECK CONSTRAINT [FK_seguimientoAuditoriasPorProceso_usuario];
		ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] WITH CHECK ADD CONSTRAINT [CK_seguimientoAuditoriasPorProcesoEstado] CHECK (([Estado]='A' OR [Estado]='C' OR [Estado]='T' OR [Estado]='E' OR [Estado]='I'));
		ALTER TABLE [dbo].[SeguimientoAuditoriasPorProceso] CHECK CONSTRAINT [CK_seguimientoAuditoriasPorProcesoEstado];
		EXEC sys.sp_addextendedproperty @name=N'MS_Description', @value=N'''I'':Por iniciar, ''E'': En ejecucion, ''T'': Terminado, ''C'': Anulado o Cancelado ''A'':Aplazado' , @level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'SeguimientoAuditoriasPorProceso', @level2type=N'CONSTRAINT',@level2name=N'CK_seguimientoAuditoriasPorProcesoEstado';
		PRINT 'Se han creado con exito objetos SeguimientoAuditoriasPorProceso.'
	END


--ALTER TABLE INT_AuditoriaEstudio
--	DROP CONSTRAINT FK_INT_AuditoriaEstudio_TrabajoAudCandidatoInternas1
	
--ALTER TABLE INT_AuditoriaEstudio
--	DROP CONSTRAINT FK_INT_AuditoriaEstudioTrabajoAuditoria


--ALTER TABLE INT_AuditoriaEstudio
--	ADD CONSTRAINT FK_INT_AuditoriaEstudio_AuditoriasPorProceso FOREIGN KEY (idTrabajo)
--    REFERENCES AuditoriasPorProceso(idProcesoAuditoria)

--ALTER TABLE INT_AuditoriaEstudio
--	ADD CONSTRAINT FK_INT_AuditoriaEstudio_TrabajoAuditoria FOREIGN KEY (idDetalle)
--    REFERENCES TrabajoAuditoria(idTrabajoAuditoria)
	
PRINT 'Actualizando Menu Identificar Amenazas por Categoria de Riesgo...'
UPDATE menu
	SET descripcion = 'Identificar Amenazas por Categoria de Riesgo'
	where idMenu = '04040304'
PRINT 'Fin actualizacion Menu Identificar Amenazas por Categoria de Riesgo.'

PRINT 'Modificando tabla CartadeEntrega...'
ALTER TABLE CartadeEntrega
	ADD periodoRevisadoDesde DATETIME NULL,
		periodoRevisadoHasta DATETIME NULL
GO

DECLARE		@idCarta				INT,
			@periodoRevisado  		INT									
	BEGIN
		DECLARE	curCartadeEntrega CURSOR LOCAL FOR
			SELECT	idCarta, periodoRevisado
				FROM CartadeEntrega
		
		OPEN curCartadeEntrega
			FETCH NEXT FROM curCartadeEntrega INTO @idCarta, @periodoRevisado
			WHILE @@FETCH_STATUS = 0 BEGIN
				BEGIN TRANSACTION
					UPDATE CartadeEntrega
						SET periodoRevisadoDesde = CONVERT(DATETIME, CONVERT(char(8), @periodoRevisado)),
							periodoRevisadoHasta = CONVERT(DATETIME, CONVERT(char(8), @periodoRevisado))
						WHERE idCarta = @idCarta
				COMMIT TRANSACTION
				FETCH NEXT FROM curCartadeEntrega INTO @idCarta, @periodoRevisado
			END
	END
PRINT 'Fin Modificacion tabla CartadeEntrega.'

PRINT 'Creando objetos ParametrizacionAutenticacionLDAP...'
IF EXISTS (select 1 from sys.tables where name = 'ParametrizacionAutenticacionLDAP')
	BEGIN
		PRINT 'Ya existen los objetos.'
	END
ELSE
	BEGIN
		CREATE TABLE [dbo].[ParametrizacionAutenticacionLDAP](
			[Empresa] [int] NOT NULL,
			[codigoPerfilNuevosUsuarios] [varchar](255) NOT NULL,
			[servidorLDAP] [sysname] NOT NULL,
			[parametrosAtributoUsuarios] [varchar](255) NOT NULL,
			[sufijoEmailUsuario] [sysname] NOT NULL,
			[cedulaUsuarioDefault] [varchar](12) NOT NULL,
			[modoAutenticacion] [varchar](12) NOT NULL,
			[nombreDominio] [sysname] NOT NULL,
			[activeDirectoryPath] [sysname] NOT NULL,
			[loginAdmin] [varchar](100) NOT NULL
		) ON [PRIMARY];
		PRINT 'Se han creado con exito objetos ParametrizacionAutenticacionLDAP.'
	END
PRINT 'Generando objetos para SP_GeneraBackupBDCompleto...'
IF EXISTS (select 1 from sys.procedures where name = 'SP_GeneraBackupBDCompleto')
	BEGIN
		PRINT 'Ya existen los objetos.'
		DROP PROCEDURE SP_GeneraBackupBDCompleto;
		PRINT 'Objetos para SP_GeneraBackupBDCompleto eliminados con exito.'		
	END
GO
CREATE PROCEDURE [dbo].[SP_GeneraBackupBDCompleto] (@Ruta varchar(1000),@idUsuario as int,@comentarios as varchar(1000), @NombreBackup as varchar(1000) out) AS
	DECLARE @Mensaje VarChar(2000),
			@fecha varchar(20),
			@Hora varchar(20),
			@archivo varchar(250),
			@base varchar(200)			
	BEGIN
		SET @Fecha=convert(varchar(10),getdate(),112)
		SET @Hora= convert(varchar(10),Datename(Hour,getdate()),108)+'_'+convert(varchar(10),datepart(mi,getdate()),108)+'_'+convert(varchar(10),datepart(ss,getdate()),108)
		SELECT @base = db_name()   
		SELECT @NombreBackup ='AudiRisk_'+@Fecha+'_'+@Hora+'.bak'
		SET @archivo=@Ruta+'\'+@NombreBackup
		
		BACKUP DATABASE @base
			TO DISK = @archivo
			WITH noformat, init, NAME=N'BKP FULL de AUDIRISK', skip, norewind, nounload, stats=10
	END
GO
PRINT 'Objetos para SP_GeneraBackupBDCompleto creados con exito.'
	
------------------------------------------------------------------------------------------
-- Fin Script 26 Mayo 2015 Oscar Garcia	                  	                        --
------------------------------------------------------------------------------------------